YouDieIEmote = LibStub("AceAddon-3.0"):NewAddon("YouDieIEmote", "AceConsole-3.0","AceEvent-3.0")

function YouDieIEmote:OnInitialize()  
    local defaults = {
    char = {
		EnabledState = true,
		Emotion = "GLOAT"
		}
	}

	YouDieIEmote.db = LibStub("AceDB-3.0"):New("YouDieIEmoteDB", defaults)
  
	YouDieIEmote:RegisterChatCommand("youdie", "slashfunc")
	YouDieIEmote:RegisterChatCommand("YouDieIEmote", "slashfunc")
	YouDieIEmote:Print("v1.2 loaded")
end

function YouDieIEmote:slashfunc(input)
	local Race = UnitRace("player")
	local Gender = ""
	
	if UnitSex("player") == 2 then
		Gender = "Male"
	else
		Gender = "Female"
	end
	
	if input == "" or input == "help" then
		print("YouDieIEmote options menu.")
		print("/youdie gloat (Set emote to gloat)")
		print("/youdie mourn (Set emote to mourn)")
		print("/youdie train (Set emote to train)")
		print("/youdie sigh (Set emote to train)")
		print("/youdie applaud (Set emote to applaud)")
		print("/youdie goodbye (Set emote to goodbye)")
		print("/youdie golfclap (Set emote to golfclap)")
		print("/youdie disable (Disables the addon)")
		print("/youdie info (Prints current settings)")
		print("YouDieIEmote is: " .. InfoYouDieIEmote(YouDieIEmote.db.char.EnabledState))
	end

	if input == "enable" then
		PlaySoundFile("sound\\interface\\iquestcomplete.ogg")
		enableYouDieIEmote()
	end
	
	if input == "disable" then
		PlaySoundFile("sound\\interface\\igquestfailed.ogg")
		disableYouDieIEmote()
	end
	
	if input == "gloat" then
		YouDieIEmote.db.char.Emotion = "GLOAT"
		PlaySoundFile("sound\\character\\".. Race .."\\".. Race .. Gender .."\\".. Race .. Gender .."laugh01.ogg")
		enableYouDieIEmote()
	end	
	
	if input == "mourn" then
		YouDieIEmote.db.char.Emotion = "MOURN"
		PlaySoundFile("sound\\character\\".. Race .."\\".. Race .. Gender .."\\".. Race .. Gender .."cry01.ogg")
		enableYouDieIEmote()
	end
	
	if input == "train" then
		YouDieIEmote.db.char.Emotion = "TRAIN"
		PlaySoundFile("sound\\character\\".. Race .."\\".. Race .. Gender .."\\".. Race .. Gender .."choochoo01.ogg")
		enableYouDieIEmote()
	end
	
	if input == "sigh" then
		YouDieIEmote.db.char.Emotion = "SIGH"
		PlaySoundFile("sound\\character\\".. Race .."\\".. Race .. Gender .."\\".. Race .. Gender .."sigh01.ogg")
		enableYouDieIEmote()
	end	
	
	if input == "applaud" then
		YouDieIEmote.db.char.Emotion = "APPLAUD"
		PlaySoundFile("Interface\\AddOns\\YouDieIEmote\\Media\\Sounds\\clapping.ogg")
		enableYouDieIEmote()
	end
	
	if input == "goodbye" then
		YouDieIEmote.db.char.Emotion = "GOODBYE"
		PlaySoundFile("sound\\character\\".. Race .."\\".. Race .."vocal".. Gender .."\\".. Race .. Gender .."goodbye01.ogg")
		enableYouDieIEmote()
	end	
		
	if input == "golfclap" then
		YouDieIEmote.db.char.Emotion = "GOLFCLAP"
		PlaySoundFile("Interface\\Addons\\YouDieIEmote\\Media\\Sounds\\clapping.ogg")
		enableYouDieIEmote()
	end
	
	if input == "info" then
		print("YouDieIEmote is: " .. InfoYouDieIEmote(YouDieIEmote.db.char.EnabledState))
	end
end

function toggleEnable()
	if isEnabled() then
		disableYouDieIEmote()
	else
		enableYouDieIEmote()
	end
end

function enableYouDieIEmote()
	YouDieIEmote.db.char.EnabledState = true
	print("YouDieIEmote is: " .. InfoYouDieIEmote(YouDieIEmote.db.char.EnabledState))
end

function disableYouDieIEmote()
	YouDieIEmote.db.char.EnabledState = false
	print("YouDieIEmote is: Disabled")
end

function InfoYouDieIEmote(bool)
	if bool then 
		return YouDieIEmote.db.char.Emotion 
	else
		return "Disabled" 
	end
end

function isEnabled()
	return YouDieIEmote.db.char.EnabledState 
end

function YouDieIEmote:OnEnable()
  	self:RegisterEvent("ADDON_LOADED","SetupYouDieIEmote")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","ActionYouDieIEmote")
end

function YouDieIEmote:SetupYouDieIEmote()
	if event == "ADDON_LOADED" then
		if YouDieIEmote.db.char.EnabledState == nil then
			YouDieIEmote.db.char.EnabledState = true
		end
		if YouDieIEmote.db.char.Emotion == nil then
			YouDieIEmote.db.char.Emotion = "GLOAT"
		end
	end	
end

function YouDieIEmote:ActionYouDieIEmote(...)
	if YouDieIEmote.db.char.EnabledState == true then
		local arg0, arg1, event, arg3, arg4, caster, arg6, arg7, arg8, target, arg10, arg11, arg12, arg13 = select(1, ...);
		if (event == "UNIT_DIED") and (UnitInRange(target)) and (UnitPlayerControlled(target))then
			DoEmote(YouDieIEmote.db.char.Emotion,target)
		end
	end
end